<template>
  <div class="userMenu">
    <div class="userMenu-login">
      <span class="userMenu-avatar">
        <img
          v-if="hasProfileOrganization"
          svg-inline
          src="~/assets/svg/redesign/avatar-company.svg">
        <img
          v-if="hasProfileUser"
          svg-inline
          src="~/assets/svg/redesign/avatar-user.svg">
      </span>
      <span class="userMenu-mail __hide-shadow">
        {{ auth && auth.displayedName }}
      </span>

      <img
        svg-inline
        src="assets/svg/redesign/cross.svg">
    </div>

    <!-- <div class="userMenu-name">
      {{ authUserTitle }}
    </div> -->

    <nav class="profileNavigation">

      <flink
        href="/cabinet/wrench/profile"
        domain="main"
        class="profileNavigation-link">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-my.svg">
        </span>
        <span>Настройки профиля</span>
      </flink>

      <flink
        href="/cabinet/wrench/notification-setup"
        domain="main"
        class="profileNavigation-link _notifications-settings">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/icons/i-profile-notification.svg">
        </span>
        <span>Настройка уведомлений</span>
      </flink>

      <AppProfileLinks :auth="auth"/>

      <div class="profileNavigation-group">
        <!--  TODO: Заменить на компонент AppButton hotfix 1.41.1-->
        <button
          class="buttonAsLink profileNavigation-link _logout _light"
          @click="logout">
          Выход
        </button>
      </div>

      <div class="userMenu-comment">
        Другие разделы “Личного кабинета” доступны в полной версии сайта
      </div>
    </nav>

  </div>
</template>

<script>
import AppProfileLinks from '~/components/redesign/app-user/app-profile-links';
import AppButton from '../app-buttons/app-button';

export default {
  name: 'AppUserMenu',
  components: {
    AppButton,
    AppProfileLinks,
  },
  props: {
    auth: {
      type: Object,
      default() { return null; },
    },
  },
  computed: {
    authUserTitle() {
      if (this.auth) {
        if (!this.auth.isOrganization && this.auth.userProfile) {
          return this.auth.userProfile.firstName;
        }

        if (this.auth.organization && this.auth.organization.legalName) {
          return this.auth.organization.legalName;
        }

        if (this.auth.organization && this.auth.organization.legals.length) {
          return this.auth.organization.legals[0].name;
        }

        if (this.auth.displayedName) {
          return this.auth.displayedName;
        }

        return '';
      }

      return '';
    },
    hasProfileOrganization() {
      return Boolean(this.auth)
        && Boolean(this.auth.isOrganization);
    },
    hasProfileUser() {
      return Boolean(this.auth)
        && Boolean(!this.auth.isOrganization);
    },
  },
  methods: {
    logout() {
      this.$emit('logout');
    },
  },
};
</script>

<style lang="postcss">
.userMenu {
  width: 100%;
  padding: 1.25rem;

  &-login {
    display: flex;
    align-items: center;
  }

  &-mail {
    display: block;
    width: 100%;
    padding-right: 1rem;
    overflow: hidden;
  }

  &-avatar {
    display: inline-flex;
    flex-shrink: 0;
    justify-content: center;
    align-items: center;
    margin-right: 0.375rem;
    border-radius: 50%;
  }

  .profileNavigation {
    &-link {
      display: block;
      color: var(--color-main);
      border: none;
      background-color: transparent;
      cursor: pointer;
      transition: color 0.1s var(--transition-easeOutQuad);
      &._light {
        color: var(--color-main-lightest);
      }

      &:hover, &:active, &:focus {
        color: var(--link-color);
      }
      .-accent {
        color: var(--error-color);
        font-weight: bold;
      }
    }
  }

  @media only screen and ( min-width: 981px ) {
    &-login, &-name {
      padding-bottom: 0.5rem;
      margin-bottom: 0.5rem;
      border-bottom: 1px solid var(--border-color-main);
      font-weight: var(--font-weight-bold);
      font-size: 0.75rem;
      cursor: default;
    }

    &-login {
      .svg.svgCross {
        display: none;
      }
    }

    &-mail {
      max-width: 14rem;
    }

    &-name {
      margin-bottom: 0.5rem;
      border-bottom: 1px solid var(--border-color-main);
    }

    &-avatar {
      width: 1.75rem;
      height: 1.75rem;
      background-color: var(--header-button-bg);

      > .svg.svgAvatar {
        width: 1.5rem;
        height: auto;
        fill: var(--bg-main);
      }
    }

    &-comment {
      display: none;
    }

    .profileNavigation {
      &-group {
        .profileNavigation-link:first-of-type {
          padding-top: 1.5rem;
        }
      }

      &-link {
        padding: 0.25rem 0;
        font-size: 0.75rem;
        &._notifications-settings {
          display: none;
        }
      }
      .icon {
        display: none;
      }

      &.linkLogout {
        margin-top: 1.5rem;
      }

    }

  }

  @media only screen and ( max-width: 980px ) {
    padding: 0;

    &-login {
      padding: 1rem 1.25rem;
      font-size: 0.875rem;
      font-weight: var(--font-weight-bold);
      border-bottom: 1px solid var(--border-color-main);

      .svg.svgCross {
        margin-left: auto;
        margin-top: -3rem;
        width: 1rem;
        height: 1rem;
        fill: var(--border-color-active);
      }
    }

    &-avatar {
      width: 1.75rem;
      height: 1.75rem;
      margin-right: 0.625rem;
      background-color: var(--color-main);

      > .svg.svgAvatar {
        width: 1.5rem;
        height: auto;
        fill: var(--bg-main);
      }
    }

    &-name {
      padding: 1rem 1.25rem 1rem 3.75rem;
      font-size: 0.875rem;
      font-weight: var(--font-weight-bold);
    }

    &-comment {
      display: block;
      padding: 2rem 1.25rem 0;
      font-size: 0.75rem;
    }

    .profileNavigation {
      &-link {
        display: flex;
        align-items: center;
        margin: 0;
        padding: 1rem 1.25rem;
        width: 100%;
        font-size: 0.875rem;
        border-top: 1px solid var(--border-color-main);
        color: var(--color-main);

        .icon {
          display: inline-flex;
          align-items: center;
          width: 2.5rem;
          height: 100%;
          .svg {
            width: auto;
            height: 1.25rem;
            fill: var(--color-main);
          }
        }

        &._garage,
        &._check-auto,
        &._clicks,
        &._history,
        &._warehouse,
        &._about-me,
        &._my-requests,
        &._my-reviews,
        &._price,
        &._inbox,
        &._outbox,
        &._parts-searched {
          display: none;
        }

        &._logout {
          padding-left: 3.75rem;
        }
      }
    }
  }
}
</style>
